package com.ywt.mg.web.controllers.hospital;

import com.ywt.mg.core.MGRight;
import com.ywt.mg.core.utils.Checker;
import com.ywt.mg.core.utils.serializers.JsonSerializer;
import com.ywt.mg.domain.models.ConstantDef;
import com.ywt.mg.params.checkupBooking.QueryCheckUpOrderListRequest;
import com.ywt.mg.services.AuthService;
import com.ywt.mg.services.CheckUpOrderService;
import com.ywt.mg.services.DownloadRecordService;
import com.ywt.mg.services.IdGenerator;
import com.ywt.mg.web.BaseResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController("/hosp/checkUp")
@RequestMapping({"/hosp/checkUp"})
@MGRight
public class HospCheckUpOrderController {

    private static Logger logger = LoggerFactory.getLogger(HospCheckUpOrderController.class);

    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private DownloadRecordService downloadRecordService;

    @Autowired
    private AuthService authService;

    @Autowired
    private CheckUpOrderService checkUpOrderService;


    @RequestMapping({"/downloadCheckUpOrderList"})
    public BaseResponse downloadDepositList(@RequestBody QueryCheckUpOrderListRequest request) {
        int currentAdminId = Checker.getIntegerValue(authService.getCurrentAdminId());
//        request.setCurrentAdminId(currentAdminId);
        // 插入记录
        Integer hospital = 0;
        String hosp = "";
//        if(request.getHosp()> 0){
            hospital = authService.getCurrentHospitalId();
            hosp = hospital.toString();
            request.setHospitalId(hosp);
//        }
        int downloadRecordId = idGenerator.genDownloadRecordId();
        String name = "体检缴费";
        String fileName = "体检缴费";
        String excelSuffixFormat = ConstantDef.EXCEL_SUFFIX_FORMAT;
        String paramUrl = "/hosp/checkUp/downloadCheckUpOrderList";
        String paramJson = JsonSerializer.toJson(request);
        downloadRecordService.getOrInsertDownloadRecordByHosp(downloadRecordId, name, fileName + excelSuffixFormat, paramUrl, paramJson);
        Thread t = new Thread() {
            @Override
            public void run() {
                checkUpOrderService.downloadCheckUpOrderListNew(downloadRecordId, fileName, request);
            }
        };
        t.start();
        return new BaseResponse().succeed("后台下载中...");
    }

    @RequestMapping({"/downloadCheckUpOrderBillList"})
    public BaseResponse downloadCheckUpOrderBillList(@RequestBody QueryCheckUpOrderListRequest request) {
        int currentAdminId = Checker.getIntegerValue(authService.getCurrentAdminId());
//        request.setCurrentAdminId(currentAdminId);
        // 插入记录
        Integer hospital = 0;
        String hosp = "";
//        if(request.getHosp()> 0){
        hospital = authService.getCurrentHospitalId();
        hosp = hospital.toString();
        request.setHospitalId(hosp);
        // 插入记录
        int downloadRecordId = idGenerator.genDownloadRecordId();
        String name = "体检缴费对账数据";
        String fileName = "体检缴费对账数据";
        String excelSuffixFormat = ConstantDef.EXCEL_SUFFIX_FORMAT;
        String paramUrl = "/hosp/checkUp/downloadCheckUpOrderBillList";
        String paramJson = JsonSerializer.toJson(request);
        downloadRecordService.getOrInsertDownloadRecordByHosp(downloadRecordId, name, fileName + excelSuffixFormat, paramUrl, paramJson);
        Thread t = new Thread() {
            @Override
            public void run() {
                checkUpOrderService.downloadOutPatientOrderBillListNew(downloadRecordId, fileName, request);
            }
        };
        t.start();
        return new BaseResponse().succeed("后台下载中...");
    }
}
